#!/bin/bash

fqdn=$(awk -F "=" '/DynDNS/ {print $2}' ./wg0.config)
act_ip=$(ping -q -W1 -c1 $fqdn | head -n1 | cut -d "(" -f2 | cut -d ")" -f1)
prev_ip=$(sed -n 4p ./wg0.config | grep -oE "\b([0-9]{1,3}\.){3}[0-9]{1,3}\b")

# make servicename by replacing . with _
act_service=$(echo "vpn_${act_ip}" | tr . _)
prev_service=$(echo "vpn_${prev_ip}" | tr . _)

if [ "$act_service" = "$prev_service" ]; then
  iseq=true
  echo "DNS IP doesn't changed"
else
  # replace line 4 in wg0.config with actual ip
  sed -i '4s/.*/Host = '$act_ip'/' ./wg0.config
  iseq=false
  echo "DNS IP different"
fi

case "$1" in
  start) 
    if [ -z "$(wg)" ]; then
      # wireguard is not connected
      connmanctl connect $act_service
    else
      # wireguard is connected with different DNS IP
      if [ "$iseq" != true ]; then
        connmanctl disconnect $prev_service
        connmanctl connect $act_service
     fi
   fi ;;
  restart)
    connmanctl disconnect $prev_service
      connmanctl connect $act_service ;;
  stop)
    connmanctl disconnect $act_service ;;
esac
